#LogTo("criteria5.log");;



Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank4.g");
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank5.g");


######################
#creating rank 5 diagrams, by shape
######################

##############################################################################################################
#a triangle in the middle
##############################################################################################################

tm5:=[];;
for d in Hta4 do
 for e in Hta4 do
  if d[1]=e[3] and d[2]=e[2] and d[3]=e[1] and d[6]=e[8]
   and d[7]=e[7] and d[8]=e[6]
   and [e[5],e[4],d[1],d[2],d[3],d[4],d[5]] in Hli4
  then Add(tm5,
   [e[5],e[4],d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8]]);
  fi;
 od;
od; 		    
tm5:=Zet(tm5);;
Number(tm5);
#194


inc:=[];;
for d in Htm5 do
if d in tm5 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

tm5bad:=[];
for d in tm5 do
if d in Htm5 then
else
Add(tm5bad,d);
fi;
od;
Number(tm5bad);
#168

##############################################################################################################
#a triangle in the extreme/tadpole
##############################################################################################################

ta5:=[];
for d in Hta4 do
	for e in Hli4 do
		if d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] 
		and [d[7],d[8],e[3],e[4],e[5],e[6],e[7]] in Hli4
		then Add(ta5,[d[1],d[2],d[3],d[4],d[5],e[6],e[7],d[6],d[7],d[8]]);
		fi;
	od;
od; 	
ta5:=Zet(ta5);;	    
Number(ta5);
#728


inc:=[];;
for d in Hta5 do
if d in ta5 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

ta5bad:=[];
for d in ta5 do
if d in Hta5 then
else
Add(ta5bad,d);
fi;
od;
Number(ta5bad);
#464

##############################################################################################################
# d5 type diagrams
##############################################################################################################

d5:=[];
for d in Hli4 do
	for e in Hli4 do
		if d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7] 
		and [d[1],d[2],d[3],d[4],d[5],e[2],e[1]] in Hd4
		then Add(d5,[d[1],d[2],d[3],d[4],d[5],d[6],d[7],e[2],e[1]]);
		fi;
	od;
od; 		    
Number(d5);
#1035

inc:=[];;
for d in Hd5 do
if d in d5 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

d5bad:=[];;
for d in d5 do
if d in Hd5 then
else
Add(d5bad,d);
fi;
od;

Number(d5bad);
#710

##############################################################################################################
# lines
##############################################################################################################

#build:
li5:=[];
for d in Hli4 do
	for e in Hli4 do
		if d[3]=e[1] and d[4]=e[2] and d[5]=e[3] and d[6]=e[4] and d[7]=e[5] 
		then Add(li5,[d[1],d[2],d[3],d[4],d[5],d[6],d[7],e[6],e[7]]);
		fi;
	od;
od; 	
li5s:=Zet(li5);;	    
Number(li5s);
#6115

#inclusion

inc:=[];
for d in Hli5 do
if d in li5 then
else
Add(inc,d);
fi;
od;

Number(inc);
#0, all included.

#we remove the ones in the list from the constructed ones

li5bad:=[];;
for d in li5 do
if d in Hli5 then
else
Add(li5bad,d);
fi;
od;

Number(li5bad);
#3136


##############################################################################################################
# criteria
##############################################################################################################


#######################
#tadpoles
######################

#Criterium I for tadpoles (crite) for triangle in the middle (critm) and for d5 (crid51):

crite:=function(d)
local k;
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10]^n] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[5]^(n^2)*d[4]^n*d[3],d[6]^n,d[7],d[8],d[9],d[10]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k< mv(d[5],d[4]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8],d[9],d[10]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k< mv(d[7],d[6]) +1 then return 
	0; 
	else
k:=1;
		if [d[9],d[8]*d[10],d[1]*d[2]*d[3],d[4],d[5],d[6],d[7]] in Hli4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1]*d[8]*d[9],d[2]*d[10],d[3],d[4],d[5],d[6],d[7]] in Hli4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[8]*d[2],d[3]*d[10]*d[9],d[4],d[5],d[6],d[7]] in Hli4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;


critm:=function(d)
local k;
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[2],d[1])] do
		if [d[1]*d[2]^n*d[3]^(n^2),d[4]^n,d[5],d[6],d[7],d[8]^n,d[9],d[10]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k< mv(d[2],d[1]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[7]^(n^2)*d[6]^n*d[5],d[4],d[3],d[2],d[1],d[10],d[9],d[8]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[5]^(n^2)*d[6]^n*d[7],d[4]^n,d[3],d[2],d[1],d[10]^n,d[9],d[8]] in Hta4 then
		k:=k+1;
		fi;
	od;
	if k< mv(d[5],d[6]) +1 then return 
	0; 
	else
k:=1;
		if [d[1],d[2],d[3]*d[8]*d[9],d[4]*d[10],d[5],d[6],d[7]] in Hli4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2],d[3],d[4]*d[8],d[5]*d[10]*d[9],d[6],d[7]] in Hli4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2],d[3]*d[4]*d[5],d[6],d[7],d[8]*d[10],d[9]] in Hd4 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

crid51:=function(d)
local k,t;
t:=Permuted(d,(1,9)(2,8));
k:=1;
	for n in [1..mv(d[3],d[8])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[8]^n*d[9],d[4]^n,d[5],d[6],d[7]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[8])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[9],d[8])] do
		if [d[1],d[2],d[3]*d[8]^n*d[9]^(n^2),d[4],d[5],d[6],d[7]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[8])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[8])] do
		if [t[1],t[2]^n,t[3]^(n^2)*t[8]^n*t[9],t[4]^n,t[5],t[6],t[7]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[8])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[9],t[8])] do
		if [t[1],t[2],t[3]*t[8]^n*t[9]^(n^2),t[4],t[5],t[6],t[7]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[9],t[8])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8]^n,d[9]] in Hd4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[3]*d[4]^n*d[5]^(n^2),d[6]^n,d[7],d[8],d[9]] in Hd4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9]] in Hd4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[5]*d[6]^n*d[7]^(n^2),d[8],d[9]] in Hd4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6])+1 then return 
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

#we apply Criterium I

lte:=[];
for d in ta5bad do
if crite(d)=1 then
Add(lte,d);
fi;
od;
Number(lte);
#96

#we remove permutations 
lteclean:=[lte[1]];
for d in lte do
if d in lteclean or Permuted(d,(1,9)(2,10)) in lteclean then
else
Add(lteclean,d);
fi;
od;
Number(lteclean);
#48


#we remove those that reflect in vertex 2 to a triangle in the middle that does not pass the criterium critm
ltee1:=[];;
for d in lteclean do
if d[3]<>-F1 then
Add(ltee1,d);
else 
	if d[2]*d[4]=F1 or critm([d[9]*d[10]*d[3],d[10]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[2]^-1,d[1]*d[2]*d[3],d[2]*d[4]])=1 then
	Add(ltee1,d);
	fi;
fi;
od;
Number(ltee1);
#10

#we reflect at vertex 2 when it is -1 and check if it is a d5 diagram. If so, we apply crid51 to its reflection 1 (gives again a d5).
 
ltee2:=[];;
for d in ltee1 do
if d[3]<>-F1 then Add(ltee2,d);
elif d[2]*d[4]<>F1 then Add(ltee2,d);
elif d[10]*d[4]<>F1 then Add(ltee2,d);
elif d[1]*d[2]*d[3]<>-F1 then Add(ltee2,d);
elif crid51([d[1]*d[2]*d[3],d[2],d[1],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[10]^-1,d[3]*d[9]*d[10]])=1 then Add(ltee2,d);
else
fi;
od;
Number(ltee2);
#8

#we reflect at vertices 3 and 4 and check if these new tadpoles are in the list

ltee3:=[];;
for d in ltee2 do
if d[5]<>-F1 then Add(ltee3,d);
elif d[6]*d[4]<>F1 then Add(ltee3,d);
elif [d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10]] in ltee2 then Add(ltee3,d);
else
fi;
od;
Number(ltee3);
#2

ltee4:=[];;
for d in ltee3 do
if d[7]<>-F1 then Add(ltee4,d);
elif [d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8],d[9],d[10]] in ltee3 then Add(ltee4,d);
else
fi;
od;
Number(ltee4);
#0
#all down.


#######################
#triangle in the middle
######################

ltm:=[];
for d in tm5bad do
if critm(d)=1 then
Add(ltm,d);
fi;
od;

#we remove permutations 
ltmclean:=[ltm[1]];
for d in ltm do
if d in ltmclean or Permuted(d,(1,7)(2,6)(3,5)(8,10)) in ltmclean then
else
Add(ltmclean,d);
fi;
od;
Number(ltmclean);
#2

#we see that the reflection at vertex 2 (which is -1 for both diagrams) gives a tadpole not in the list:

ltmfinal:=[];;
for d in ltmclean do
if [d[1]*d[2]*d[3],d[2]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[2]*d[8],d[3]*d[8]*d[9],d[8]^-1] in Hta5 then Add(ltmclean,d);
else
fi;
od;

Number(ltmfinal);
#0

##############################################################################################################
#criteria for  d5
##############################################################################################################

#we apply Criterium I


ld51:=[];
for d in d5bad do
if crid51(d)=1 then
Add(ld51,d);
fi;
od;

Number(ld51);
#48


#we check if the reflection at vertex 2 creates a triangle (tadpole or in the middle) and use previous criteria
f:=function(d)
local k;
k:=0;
if d[3]^2*d[2]*d[8]<>F1 then 
k:=k+1;
fi;
if d[3]^2*d[2]*d[4]<>F1 then 
k:=k+1;
fi;
if d[3]^2*d[4]*d[8]<>F1 then 
k:=k+1;
fi;
return 
k;
end;

crid52:=function(d)
if d[3]<>-F1 then
return 1;
elif
f(d)=0 then
return 1;
elif
f(d)=1 and d[2]*d[8]<>F1 then
return 
crite([-d[1]*d[2],d[2]^-1,-F1,d[4]^-1,-d[4]*d[5],d[6],d[7],d[2]*d[8],-d[9]*d[8],d[8]^-1]);
elif
f(d)=1 and d[2]*d[4]<>F1 then 
return
critm([-d[9]*d[8],d[8]^-1,-F1,d[4]^-1,-d[4]*d[5],d[6],d[7],d[2]^-1,-d[1]*d[2],d[2]*d[4]]);
elif
f(d)=1 and d[4]*d[8]<>F1 then
return
critm([-d[1]*d[2],d[2]^-1,-F1,d[4]^-1,-d[4]*d[5],d[6],d[7],d[8]^-1,-d[8]*d[9],d[8]*d[4]]);
fi;
end;

ld52:=[];
for d in ld51 do
if crid52(d)=1 then
Add(ld52,d);
fi;
od;
Number(ld52);
#16

#we remove permutations
ld5clean:=[ld52[1]];
for d in ld52 do
if d in ld5clean or Permuted(d,(1,9)(2,8)) in ld5clean then
else
Add(ld5clean,d);
fi;
od;
Number(ld5clean);
#10

#we apply the criteria to reflections 1 and 5 when the vertex is -1.

crid5:=d->crid51(d)*crid52(d);

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[9]*d[8]*d[3],d[4],d[5],d[6],d[7],d[8]^-1,d[9]];
else return
d;
fi;
end;

crid5r:=d->crid5(rho1(d))*crid5(rho5(d));

ld53:=[];
for d in ld5clean do
if crid5r(d)=1 then
Add(ld53,d);
fi;
od;
Number(ld53);
#4


#we reflect at vertex 2 when it is -1 and check if it is a tm diagram. If so, we check if it is in the list (case already analyzed).
 
ld54:=[];;
for d in ld53 do
if d[3]<>-F1 then Add(ld54,d);
elif d[4]*d[8]=F1 then Add(ld54,d);
elif [d[1]*d[2]*d[3],d[2]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[8]^-1,d[3]*d[9]*d[8],d[4]*d[8]]in Htm5 then Add(ld54,d);
else
fi;
od;
Number(ld54);
#2

#we reflect at vertex 5 (=-1) and 4 and check if these new D5 are still this list

ld5final:=[];;
for d in ld54 do
if d[9]<>-F1 then Add(ld5final,d);
elif [d[1],d[2],d[3]*d[8]*d[9],d[4],d[5],d[6],d[7],d[8]^-1,d[9]] in ld54 then Add(ld5final,d);
else
fi;
od;
Number(ld5final);
#0


#####################################################################################
#we analyze lines5
#####################################################################################


#we clean permutations
li500:=[li5bad[1]];;
for d in li5bad do
if d in li500 or Permuted(d,(1,9)(2,8)(3,7)(4,6)) in li500 then
else
Add(li500,d);
fi;
od;

Number(li500);
#1645

#we discard lines of cartan type

crilic:=function(d)
if 
d[1]^mv(d[1],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[8])*d[8]<>F1 then return 0;
elif
d[9]^mv(d[9],d[8])*d[8]<>F1 then return 0;
else return
1;
fi;
end;


li50:=[];
for d in li500 do
if crilic(d)=0 then
Add(li50,d);
fi;
od;
Number(li50);
#1482

#we discard those that reflect into triangles

crili1:=function(d)
if d[3]=-F1 and d[2]*d[4]<>F1 then
return 0;
elif d[5]=-F1 and d[6]*d[4]<>F1 then
return 0;
elif d[7]=-F1 and d[6]*d[8]<>F1 then
return 0;
else 
return 1;
fi;
end;

li51:=[];;
for d in li50 do
if crili1(d)=1 then
Add(li51,d);
fi;
od;

Number(li51);
#603

#Criterium I

crili2:=function(d)
local k,t;
t:=Permuted(d,(1,9)(2,8)(3,7)(4,6));
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[2])] do
		if [d[1]*d[2]^n*d[3]^(n^2),d[4]^n,d[5],d[6],d[7],d[8],d[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[3]*d[4]^n*d[5]^(n^2),d[6]^n,d[7],d[8],d[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[1],t[2])] do
		if [t[1]^(n^2)*t[2]^n*t[3],t[4],t[5],t[6],t[7],t[8],t[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[1],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[2])] do
		if [t[1]*t[2]^n*t[3]^(n^2),t[4]^n,t[5],t[6],t[7],t[8],t[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[4])] do
		if [t[1],t[2]^n,t[3]^(n^2)*t[4]^n*t[5],t[6],t[7],t[8],t[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[5],t[4])] do
		if [t[1],t[2],t[3]*t[4]^n*t[5]^(n^2),t[6]^n,t[7],t[8],t[9]] in Hli4 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[5],t[4])+1 then return 
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

li52:=[];;
for d in li51 do
if crili2(d)=1 then
Add(li52,d);
fi;
od;

Number(li52);
#106

crili:=d->crili1(d)*crili2(d);

#we apply the criteria to reflections at vertices=-1 

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9]];
else return
d;
fi;
end;

rho2:=function(d)
if d[3]=-F1 then return
[d[1]*d[2]*d[3],d[2]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[8],d[9]];
else return
d;
fi;
end;

rho3:=function(d)
if d[5]=-F1 then return
[d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9]];
else return
d;
fi;
end;

#for rho5 we write the general formula, which will be needed in the sequel
rho5:=d->[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]^mv(d[9],d[8])*d[9]^(mv(d[9],d[8])^2),d[8]^-1*d[9]^(-2*mv(d[9],d[8])),d[9]];

#crili:=crili2;
crili5r:=d->crili(rho1(d))*crili(rho2(d))*crili(rho3(d))*crili(rho4(d))*crili(rho5(d));

li53:=[];
for d in li52 do
if crili5r(d)=1 then
Add(li53,d);
fi;
od;

Number(li53);
#36

#double reflections 

crili5rr:=d->
crili(rho1(rho2(d)))*crili(rho2(rho1(d)))*crili(rho2(rho3(d)))*crili(rho3(rho2(d)))*
crili(rho3(rho4(d)))*crili(rho4(rho3(d)))*crili(rho4(rho5(d)))*crili(rho5(rho4(d)))*
crili(rho1(rho3(d)))*crili(rho2(rho4(d)))*crili(rho3(rho5(d)))*
crili(rho1(rho4(d)))*crili(rho2(rho5(d)))*
crili(rho1(rho5(d)));


li54:=[];
for d in li53 do
if crili5rr(d)=1 then
Add(li54,d);
fi;
od;
Number(li54);
#2

#triple reflections

crili5rrr:=function(d)
if crili5rr(rho1(d))=0 then
return 0;
elif crili5rr(rho2(d))=0 then
return 0;
elif crili5rr(rho3(d))=0 then
return 0;
elif crili5rr(rho4(d))=0 then
return 0;
elif crili5rr(rho5(d))=0 then
return 0;
else 
return 1;
fi;
end;


li55:=[];
for d in li54 do
if crili5rrr(d)=1 then
Add(li55,d);
fi;
od;
Number(li55);
#0



