#LogTo("criteria7.log");;


Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank6.g");
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank7.g");

######################
#creating rank 7 diagrams, by shape
######################

li7:=[];;
for d in Hli6 do
	for e in Hli6 do
		if d[3]=e[1] and d[4]=e[2] and d[5]=e[3] and d[6]=e[4] and d[7]=e[5] and d[8]=e[6] and d[9]=e[7] and d[10]=e[8] and d[11]=e[9]
		then Add(li7,Concatenation(d,[e[10],e[11]]));
		fi;
	od;
od; 		    
Number(li7);
#16617


d7:=[];;
for d in Hli6 do
	for e in Hd6 do
		if d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7] and d[8]=e[8] and d[9]=e[9]
		and [e[11],e[10],d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6
		then Add(d7,Concatenation(d,[e[10],e[11]]));
		fi;
	od;
od; 		    
Number(d7);
#2067

e7:=[];;
for d in Hli6 do
	for e in He6 do
		if d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7] and d[8]=e[8] and d[9]=e[9]
		and [d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],e[10],e[11]] in Hd6
		then Add(e7,Concatenation(d,[e[10],e[11]]));
		fi;
	od;
od; 		    
Number(e7);
#121


ta7:=[];;
for d in Hli6 do
	for e in Hta6 do
		if 
		d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7] and d[8]=e[8] and d[9]=e[9]
		and [e[11],e[12],d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6
		then Add(ta7,Concatenation(d,[e[10],e[11],e[12]]));
		fi;
	od;
od; 		    
Number(ta7);
#1948


tm7:=[];;
for d in Hli6 do
	for e in Htm6 do
		if 
		d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7] and d[8]=e[8] and d[9]=e[9]
		and [e[3],e[4],e[5],e[6],e[7],e[8],e[9],d[10],d[11],e[10],e[11],e[12]] in Hta6
		then Add(tm7,Concatenation(d,[e[10],e[11],e[12]]));
		fi;
	od;
od; 		    
Number(tm7);
#20


##########################
#inclusions and bad diagrams
##########################


#for tm


#included:

Htm7[1] in tm7;
Htm7[2] in tm7;

tm7bad:=[];
for d in tm7 do
if d in Htm7 then
else
Add(tm7bad,d);
fi;
od;
Number(tm7bad);
#18


#tadpoles

inc:=[];
for d in Hta7 do
if d in ta7 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included


ta7bad:=[];
for d in ta7 do
if d in Hta7 then
else
Add(ta7bad,d);
fi;
od;
Number(ta7bad);
#988


#for e7

inc:=[];;
for d in He7 do
if d in e7 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included


e7bad:=[];;
for d in e7 do
if d in He7 then
else
Add(e7bad,d);
fi;
od;

Number(e7bad);
#82



inc:=[];;
for d in Hd7 do
if d in d7 or Permuted(d,(1,13)(2,12)) in d7  then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

d7bad:=[];;
for d in d7 do
if d in Hd7 then
else
Add(d7bad,d);
fi;
od;

Number(d7bad);
#1098

#lines


inc:=[];;
for d in Hli7 do
if d in li7 or Permuted(d,(1,13)(2,12)(3,11)(4,10)(5,9)(6,8)) in li7  then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

li7bad:=[];;
for d in li7 do
if d in Hli7 or Permuted(d,(1,13)(2,12)(3,11)(4,10)(5,9)(6,8)) in Hli7 then
else
Add(li7bad,d);
fi;
od;

Number(li7bad);
#5088


########################
#criteria, by shape
########################


########################
# triangle in the middle
########################


critm1:=function(d)
local k,n;
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[2])] do
		if [d[3]^(n^2)*d[2]^n*d[1],d[4]^n,d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12]^n,d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[2]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12]^n*d[14],d[13]] in Hd6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[5]^(n^2)*d[4]^n*d[3],d[6]^n,d[7],d[8],d[9],d[10],d[11],d[12]*d[14]^n,d[13]] in Hd6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]^n] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8]^n,d[9],d[10],d[11],d[12],d[13],d[14]] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[7],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6]^n,d[7]^(n^2)*d[8]^n*d[9],d[10],d[11],d[12],d[13],d[14]] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[9]^(n^2)*d[8]^n*d[7],d[10],d[11],d[12],d[13],d[14]] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[10])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8]^n,d[9]^(n^2)*d[10]^n*d[11],d[12],d[13],d[14]] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[10]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[11],d[10])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[11]^(n^2)*d[10]^n*d[9],d[12],d[13],d[14]] in Htm6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[11],d[10]) +1 then return 
	0; 
	else
k:=1;
		if [d[1],d[2],d[3]*d[12]*d[13],d[4]*d[14],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2],d[3],d[4]*d[12],d[5]*d[13]*d[14],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

ltm7final1:=[];
for d in tm7bad do
if critm1(d)=1 then
Add(ltm7final1,d);
fi;
od;

Number(ltm7final1);
#8

#we construct reflections 1, 4, 5 and 6 when the vertex is -1.

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12],d[13],d[14]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 and d[8]*d[10]=F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10]^-1,d[11]*d[10]*d[9],d[12],d[13],d[14]];
else return
d;
fi;
end;


rho6:=function(d)
if d[11]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[11]*d[10]*d[9],d[10]^-1,d[11],d[12],d[13],d[14]];
else return
d;
fi;
end;

##
#crit for a1,a2+a3,a3+a4,a4+a5,a6,a7 gives E6 since d[4]d[5]^2d[6]=1=d[6]d[7]^2d[8] for all in the remaining bad diagrams.
#and reflections
##

critm2:=function(d)
if [d[5]*d[6]*d[7],d[14],d[13],d[12]*d[14],d[3]*d[4]*d[5],d[6],d[7]*d[8]*d[9],d[10],d[11],d[2],d[1]] in He6 then
return 1;
else 
return 0;
fi;
end;


critmr:=d->
critm2(d)*
critm2(rho1(d))*critm2(rho4(d))*critm1(rho5(d))*critm2(rho6(d))*
critm2(rho1(rho4(d)))*critm2(rho5(rho4(d)))*critm2(rho6(rho4(d)))*
critm2(rho1(rho5(d)))*critm2(rho4(rho5(d)))*critm2(rho6(rho5(d)))*
critm2(rho1(rho6(d)))*critm2(rho5(rho6(d)))
;

ltm7final2:=[];
for d in ltm7final1 do
if critmr(d)=1 then
Add(ltm7final2,d);
fi;
od;

Number(ltm7final2);
#0, all down


###################################
#triangle in extreme (tadpole)
###################################


crite:=function(d)
local k;
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]^n] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[5]^(n^2)*d[4]^n*d[3],d[6]^n,d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8]^n,d[9],d[10],d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6]^n,d[7]^(n^2)*d[8]^n*d[9],d[10],d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]^n*d[9]^(n^2),d[10]^n,d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[10])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8]^n,d[9]^(n^2)*d[10]^n*d[11],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[10]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[11],d[10])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[11]^(n^2)*d[10]^n*d[9],d[12],d[13],d[14]] in Hta6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[11],d[10]) +1 then return 
	0; 
	else
k:=1;
		if [d[13],d[12]*d[14],d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1]*d[12]*d[13],d[2]*d[14],d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2]*d[12],d[3]*d[14]*d[13],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;


lte1:=[];
for d in ta7bad do
if crite(d)=1 then
Add(lte1,d);
fi;
od;
lte:=Zet(lte1);;
Number(lte);
#8

#actually 2: by permutations and z,z^-1. One root order 3 and one 4

#a1+a2,a2+a3,a3+a4,a5,a6,a7 give rank 6 lines not in the list:
#gap> z:=F(3);;
#gap> [-F1,z^2,-F1,z,-F1,z,z^2,z,z^2,z,z^2] in Hli6;
#false
#gap> w:=F(4);;
#gap> [-F1,w,-F1,-F1,-F1,-w,w,-w,w,-w,w] in Hli6;
#false



###############################################
# E7
##########################################


#first we discard those that reflect to triangles

crie7t:=function(d)
if d[5]<>-F1 then
return 1;
elif d[5]=-F1 and d[4]*d[6]=F1 and  d[4]*d[12]=F1 and  d[12]*d[6]=F1  then
return 1;
else
return 0;
fi;
end;


crie7c:=function(d)
local k;
k:=1;
	if [d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in He6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[10],d[11],d[12],d[13]] in He6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[12],d[13]] in He6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5]*d[12]*d[13],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

crie7:=d->crie7t(d)*crie7c(d);

e7bad1:=[];;
for d in e7bad do
if crie7(d)=1 then
Add(e7bad1,d);
fi;
od;

Number(e7bad1);
#12


#we construct reflections

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;


rho5:=function(d)
if d[9]=-F1 and d[8]*d[10]=F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10]^-1,d[9]*d[10]*d[11],d[12],d[13]];
else return
d;
fi;
end;

rho6:=function(d)
if d[11]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[10]^-1,d[11],d[12],d[13]];
else return
d;
fi;
end;

crie7r:=d->
crie7(rho6(d))*crie7(rho4(d))*crie7(rho5(d))*
crie7(rho4(rho6(d)))*crie7(rho5(rho6(d)))*crie7(rho6(rho5(d)))*
crie7(rho4(rho5(d)))*crie7(rho5(rho4(d)))*
crie7(rho4(rho5(rho6(d))))*crie7(rho4(rho6(rho5(d))))*
crie7(rho5(rho6(rho4(d))))*
crie7(rho6(rho5(rho4(d))));

e7bad2:=[];
for d in e7bad1 do
if crie7r(d)=1 then
Add(e7bad2,d);
fi;
od;

Number(e7bad2);
#0

#######################
#d7
#######################

#for d7

#first we discard those that reflect to triangles

crid7t:=function(d)
if d[3]<>-F1 then
return 1;
elif d[3]=-F1 and d[2]*d[4]=F1 and  d[4]*d[12]=F1 and  d[12]*d[2]=F1  then
return 1;
else
return 0;
fi;
end;

#we use criteria

crid7c:=function(d)
local k;
k:=1;
	if [d[13],d[12],d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[10],d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[12],d[13]] in Hd6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[12]*d[13],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli6 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

crid7:=d->crid7t(d)*crid7c(d);

d7bad1:=[];;
for d in d7bad do
if crid7(d)=1 then
Add(d7bad1,d);
fi;
od;

Number(d7bad1);
#10


#we construct reflections

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[3]*d[2]*d[1],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;


rho3:=function(d)
if d[5]=-F1 and d[6]*d[4]=F1 then return
[d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 and d[8]*d[10]=F1  then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10]^-1,d[9]*d[10]*d[11],d[12],d[13]];
else return
d;
fi;
end;

rho6:=function(d)
if d[11]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[10]^-1,d[11],d[12],d[13]];
else return
d;
fi;
end;


rho7:=d->Permuted(rho1(Permuted(d,(1,13)(2,12))),(1,13)(2,12));

crid7r:=d->
crid7(rho1(d))*crid7(rho3(d))*crid7(rho4(d))*crid7(rho5(d))*crid7(rho6(d))*crid7(rho7(d))*
crid7(rho1(rho3(d)))*crid7(rho1(rho4(d)))*crid7(rho1(rho5(d)))*crid7(rho1(rho6(d)))*crid7(rho1(rho7(d)))*
crid7(rho3(rho4(d)))*crid7(rho3(rho5(d)))*crid7(rho3(rho6(d)))*crid7(rho3(rho7(d)))*
crid7(rho4(rho3(d)))*crid7(rho4(rho5(d)))*crid7(rho4(rho6(d)))*crid7(rho4(rho7(d)))*
crid7(rho5(rho4(d)))*crid7(rho5(rho6(d)))*crid7(rho5(rho7(d)))*
crid7(rho6(rho5(d)))*crid7(rho6(rho7(d)))*
crid7(rho7(rho6(d)));

d7bad2:=[];
for d in d7bad1 do
if crid7r(d)=1 then
Add(d7bad2,d);
fi;
od;

Number(d7bad2);
#0

######################
#lines
######################


#we discard those that turn into triangles

ctl7:=function(d)
if d[3]=-F1 and d[2]*d[4]<>F1 then
return 0;
elif d[5]=-F1 and d[4]*d[6]<>F1 then
return 0;
elif d[7]=-F1 and d[6]*d[8]<>F1 then
return 0;
elif d[9]=-F1 and d[8]*d[10]<>F1 then
return 0;
elif d[11]=-F1 and d[10]*d[12]<>F1 then
return 0;
else
return 1;
fi;
end;

lifinal7:=[];;
for d in li7bad do
if ctl7(d)=1 then
Add(lifinal7,d);
fi;
od;
Number(lifinal7);
#3332;

li700:=lifinal7;;


crilic:=function(d)
if 
d[1]^mv(d[1],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[8])*d[8]<>F1 then return 0;
elif
d[9]^mv(d[9],d[8])*d[8]<>F1 then return 0;
elif
d[9]^mv(d[9],d[10])*d[10]<>F1 then return 0;
elif
d[11]^mv(d[11],d[10])*d[10]<>F1 then return 0;
elif
d[11]^mv(d[11],d[12])*d[12]<>F1 then return 0;
elif
d[13]^mv(d[13],d[12])*d[12]<>F1 then return 0;
else return
1;
fi;
end;


li70:=[];
for d in li700 do
if crilic(d)=0 then
Add(li70,d);
fi;
od;
Number(li70);
#3186


#Criterium I

crilis:=function(d)
local k,t;
t:=Permuted(d,(1,13)(2,12)(3,11)(4,10)(5,9)(6,8));
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[2])] do
		if [d[1]*d[2]^n*d[3]^(n^2),d[4]^n,d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[3]*d[4]^n*d[5]^(n^2),d[6]^n,d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8]^n,d[9],d[10],d[11],d[12],d[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[7],t[6])] do
		if [t[1],t[2],t[3],t[4],t[7]^(n^2)*t[6]^n*t[5],t[8]^n,t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[7],t[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[5],t[6])] do
		if [t[1],t[2],t[3],t[4]^n,t[5]^(n^2)*t[6]^n*t[7],t[8],t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[5],t[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[1],t[2])] do
		if [t[1]^(n^2)*t[2]^n*t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[1],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[2])] do
		if [t[1]*t[2]^n*t[3]^(n^2),t[4]^n,t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[4])] do
		if [t[1],t[2]^n,t[3]^(n^2)*t[4]^n*t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[5],t[4])] do
		if [t[1],t[2],t[3]*t[4]^n*t[5]^(n^2),t[6]^n,t[7],t[8],t[9],t[10],t[11],t[12],t[13]] in Hli6 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[5],t[4])+1 then return 
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;


li71:=[];;
for d in li70 do
if crilis(d)=1 then
Add(li71,d);
fi;
od;

Number(li71);
#8

crili:=d->ctl7(d)*crilis(d);

#we apply the criteria to reflections at vertices=-1

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho2:=function(d)
if d[3]=-F1 then return
[d[1]*d[2]*d[3],d[2]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho3:=function(d)
if d[5]=-F1 then return
[d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12],d[13]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10]^-1,d[9]*d[10]*d[11],d[12],d[13]];
else return
d;
fi;
end;

rho6:=function(d)
if d[11]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[10]^-1,d[11],d[12]^-1,d[11]*d[12]*d[13]];
else return
d;
fi;
end;

rho7:=function(d)
if d[13]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]*d[12]*d[13],d[12]^-1,d[13]];
else return
d;
fi;
end;

#crili:=crili2;
crili7r:=d->crili(rho1(d))*crili(rho2(d))*crili(rho3(d))*crili(rho4(d))*crili(rho5(d))*crili(rho6(d))*crili(rho7(d));

li72:=[];
for d in li71 do
if crili7r(d)=1 then
Add(li72,d);
fi;
od;

Number(li72);
#0



