#LogTo("criteria4.log");;

Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/basic.g");
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank3.g");
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank4t.g");

#matrix m(i,j):
M:=d->[
[-2,mv(d[1],d[2]),mv(d[1],d[6]),mv(d[1],d[9])],
[mv(d[3],d[2]),-2,mv(d[3],d[4]),mv(d[3],d[10])],
[mv(d[5],d[6]),mv(d[5],d[4]),-2,mv(d[5],d[8])],
[mv(d[7],d[9]),mv(d[7],d[10]),mv(d[7],d[8]),-2]
];;

#reflections

rho1:=v->[
v[1],
v[1]^(-2*M(v)[1,2])*v[2]^(-1),
v[1]^(M(v)[1,2]^2)*v[2]^M(v)[1,2]*v[3],
v[1]^(2*M(v)[1,2]*M(v)[1,3])*v[2]^M(v)[1,3]*v[6]^M(v)[1,2]*v[4],
v[1]^(M(v)[1,3]^2)*v[6]^M(v)[1,3]*v[5],
v[1]^(-2*M(v)[1,3])*v[6]^(-1),
v[1]^(M(v)[1,4]^2)*v[9]^M(v)[1,4]*v[7],
v[1]^(2*M(v)[1,3]*M(v)[1,4])*v[6]^M(v)[1,4]*v[9]^M(v)[1,3]*v[8],
v[1]^(-2*M(v)[1,4])*v[9]^-1,
v[1]^(2*M(v)[1,2]*M(v)[1,4])*v[9]^M(v)[1,2]*v[2]^M(v)[1,4]*v[10],
]; 

per1:=(1,7,5,3)(2,9,8,4)(6,10);;
per2:=per1^2;;
per3:=per1^3;;

rho2:=v->Permuted(rho1(Permuted(v,per1)),per3);
rho3:=v->Permuted(rho1(Permuted(v,per2)),per2);
rho4:=v->Permuted(rho1(Permuted(v,per3)),per1);

#criteria

#is cartan:
ic:=function(d)
if 
d[1]^mv(d[1],d[2])*d[2]<>F1 then return 0;
elif
d[1]^mv(d[1],d[6])*d[6]<>F1 then return 0;
elif
d[1]^mv(d[1],d[9])*d[9]<>F1 then return 0;
#
elif
d[3]^mv(d[3],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[4])*d[4]<>F1 then return 0;
elif
d[3]^mv(d[3],d[10])*d[10]<>F1 then return 0;
#
elif
d[5]^mv(d[5],d[6])*d[6]<>F1 then return 0;
elif
d[5]^mv(d[5],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[8])*d[8]<>F1 then return 0;
#
elif
d[7]^mv(d[7],d[9])*d[9]<>F1 then return 0;
elif
d[7]^mv(d[7],d[10])*d[10]<>F1 then return 0;
elif
d[7]^mv(d[7],d[8])*d[8]<>F1 then return 0;
else return
1;
fi;
end;

#criterium 2: Criterium I for m alpha_i+alpha_j,alpha_k,alpha_l.

cri2:=function(d)
local k;
k:=1;
	for n in [1..M(d)[1,2]] do
		if Hcheckr3([d[1]^(n^2)*d[2]^n*d[3],d[6]^n*d[4],d[5],d[8],d[7],d[9]^n*d[10]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[1,2]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[2,1]] do
		if Hcheckr3([d[1]*d[2]^n*d[3]^(n^2),d[6]*d[4]^n,d[5],d[8],d[7],d[9]*d[10]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[2,1]+1 then return 
	0; 
	else
k:=1;
	for n in [1..M(d)[1,3]] do
		if Hcheckr3([d[1]^(n^2)*d[6]^n*d[5],d[2]^n*d[4],d[3],d[10],d[7],d[9]^n*d[8]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[1,3]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[3,1]] do
		if Hcheckr3([d[1]*d[6]^n*d[5]^(n^2),d[2]*d[4]^n,d[3],d[10],d[7],d[9]*d[8]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[3,1]+1 then return 
	0; 
	else
k:=1;
	for n in [1..M(d)[1,4]] do
		if Hcheckr3([d[1]^(n^2)*d[9]^n*d[7],d[2]^n*d[10],d[3],d[4],d[5],d[6]^n*d[8]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[1,4]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[4,1]] do
		if Hcheckr3([d[1]*d[9]^n*d[7]^(n^2),d[2]*d[10]^n,d[3],d[4],d[5],d[6]*d[8]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[4,1]+1 then return 
	0; 
	else
k:=1;
	for n in [1..M(d)[2,4]] do
		if Hcheckr3([d[3]^(n^2)*d[10]^n*d[7],d[2]^n*d[9],d[1],d[6],d[5],d[4]^n*d[8]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[2,4]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[4,2]] do
		if Hcheckr3([d[3]*d[10]^n*d[7]^(n^2),d[2]*d[9]^n,d[1],d[6],d[5],d[4]*d[8]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[4,2]+1 then return 
	0; 
	else
k:=1;
	for n in [1..M(d)[3,4]] do
		if Hcheckr3([d[5]^(n^2)*d[8]^n*d[7],d[6]^n*d[9],d[1],d[2],d[3],d[4]^n*d[10]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[3,4]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[4,3]] do
		if Hcheckr3([d[5]*d[8]^n*d[7]^(n^2),d[6]*d[9]^n,d[1],d[2],d[3],d[4]*d[10]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[4,3]+1 then return 
	0; 
	else
k:=1;
	for n in [1..M(d)[3,2]] do
		if Hcheckr3([d[5]^(n^2)*d[4]^n*d[3],d[6]^n*d[2],d[1],d[9],d[7],d[8]^n*d[10]])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[3,2]+1 then return 
	0;
	else
k:=1;
	for n in [1..M(d)[2,3]] do
		if Hcheckr3([d[5]*d[4]^n*d[3]^(n^2),d[6]*d[2]^n,d[1],d[9],d[7],d[8]*d[10]^n])=1 then
		k:=k+1;
		fi;
	od;
	if k<M(d)[2,3]+1 then return 
	0; 
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

#criterium with  sums of  roots "1m00, 0n10, 0001" or "01m0, 00n1, 1000". This is Criterium IV
cri3b:=function(d)
local a,b,k;
k:=1;
for a in [1..M(d)[2,1]] do
for b in [1..M(d)[2,3]] do
				if
Hcheckr3([d[3]^(a^2)*d[2]^a*d[1],d[3]^(2*a*b)*d[2]^b*d[4]^a*d[6],d[3]^(b^2)*d[4]^b*d[5],d[10]^b*d[8],d[7],d[10]^a*d[9]])=1 then
				k:=k+1;
				fi;
od;
od;
if k<M(d)[2,1]*M(d)[2,3]+1 then return 
	0; 
	else
k:=1;
for a in [1..M(d)[3,2]] do
for b in [1..M(d)[3,4]] do
				if
Hcheckr3([d[5]^(a^2)*d[4]^a*d[3],d[5]^(2*a*b)*d[4]^b*d[8]^a*d[10],d[5]^(b^2)*d[8]^b*d[7],d[6]^b*d[9],d[1],d[6]^a*d[2]])=1 then
				k:=k+1;
				fi;
od;
od;
if k<M(d)[3,2]*M(d)[3,4]+1 then return 
	0; 
	else
k:=1;
return k;
fi;
fi;
end;

#we permute the matrix entries to apply this criterium -Criterium IV- to  sums of  roots "1m00, 0n01, 0001" or "10m0, 00n1, 0100". 

cri3:=function(d)
if cri3b(d)=0 then return
0;
else return
cri3b(Permuted(d,(1,3)(4,6)(9,10)));
fi;
end;

#criterium with three sums of  roots "a100, 0b10, 00c1". This is Criterium V

cri4b:=function(d)
local a,b,c,k;
k:=1;
for a in [1..M(d)[1,2]] do
for b in [1..M(d)[2,3]] do
for c in [1..M(d)[3,4]] do
				if
Hcheckr3([d[1]^(a^2)*d[2]^a*d[3],d[2]^(a*b)*d[6]^a*d[3]^(2*b)*d[4],d[3]^(b^2)*d[4]^b*d[5],d[4]^(b*c)*d[10]^b,d[5]^(c^2)*d[8]^c*d[7],d[6]^(a*c)*d[9]^a*d[4]^c*d[10]])=1 then
				k:=k+1;
				fi;
od;
od;
od;
if k<M(d)[1,2]*M(d)[2,3]*M(d)[3,4]+1 then return 
	0; 
	else
k:=1;
return k;
fi;
end;

#Permuting, we extend Criterium V to roots 
# "1a00, b010, 00c1"
# "010a, 01b0, 1c00"
# "100a, 10b0, c100"

cri4:=function(d)
local e;
e:=Permuted(d,(1,7)(3,5)(2,8)(6,10));
if cri4b(d)=0 then return
0;
elif
cri4b(Permuted(d,(1,3)(4,6)(9,10)))=0 then
return
0;
elif
cri4b(e)=0 then
return
0;
else return
cri4b(Permuted(e,(1,3)(4,6)(9,10)));
fi;
end;

#to check if it is a square
checksq:=function(d)
if d[2]<>F1 and d[4]<>F1 and d[8]<>F1 and d[9]<>F1 then
return
0;
elif d[2]<>F1 and d[10]<>F1 and d[8]<>F1 and d[6]<>F1 then
return
0;
elif d[6]<>F1 and d[10]<>F1 and d[4]<>F1 and d[9]<>F1 then
return
0; 
else return
1;
fi;
end;

checkrhosq:=d->checksq(rho1(d))*checksq(rho2(d))*checksq(rho3(d))*checksq(rho4(d));

#to check if the diagram contains a square or is a tadpole:
checkta:=function(d)
local l,l1,x;
l1:=[];
l:=[d[2],d[4],d[6],d[8],d[9],d[10]];
for x in l do
if x<>F1 then 
Add(l1,x);
fi;
od;
if Number(l1)>3 then return
1;
else return
0;
fi;
end;

checkrhota:=d->(1-checkta(rho1(d)))*(1-checkta(rho2(d)))*(1-checkta(rho3(d)))*(1-checkta(rho4(d)));
checkrho3ta:=d->1-checkta(rho3(d));

#########################################
#squares
#########################################


paste1:=function(d,t)
if d[1]=t[1] and d[6]=t[6] and d[5]=t[5] then
return
Concatenation(d,[t[3],t[4],t[2]]);
else
return
0;
fi;
end;

#we paste two triangles sharing a side
squares:=[];;
for d in tris do
	for t in tris do
		if paste1(d,t)<>0 then
			Add(squares,paste1(d,t));
		fi;
	od;
od;
cd1:=Zet(squares);;
#11230

#squares with a diagonal, takes a little time: we check that the new sides belong to the list of lines of rank 3
cd:=[];
for d in cd1 do
	if Hcheckr3([d[3],d[2],d[1],d[9],d[7]])=1 and Hcheckr3([d[3],d[4],d[5],d[8],d[7]])=1 then
Add(cd,Concatenation(d,[F1]));
fi;
od;
#406

#complete squares: for each square (pasting of two triangles) we take an extra triangle and check if it can pasted as well, generating the other diagonal.
# If so, we check that the new triangle generated by this process is in the list 

cc:=[];
for d in cd1 do
	for v in tris do
		if v[1]=d[3] and v[2]=d[2] and v[3]=d[1] and v[4]=d[9] and v[5]=d[7] 
		and Hcheckr3([d[3],d[4],d[5],d[8],d[7],v[6]])=1
			then Add(cc,Concatenation(d,[v[6]]));
		fi;
	od;
od;
#860

#clean squares
cl:=[];;
	for d in lins do
		for v in lins do
		if d[1]=v[1] and d[5]=v[5] and Hcheckr3([d[3],d[2],d[1],v[2],v[3]])=1 and Hcheckr3([d[3],d[4],d[5],v[4],v[3]])=1 then
		Add(cl,[d[1],d[2],d[3],d[4],d[5],F1,v[3],v[4],v[2],F1]);
		fi;
	od;
od; 
#4903


allsq1:=Concatenation(cd,cc);;
allsq2:=Concatenation(allsq1,cl);;
allsq:=Zet(allsq2);;
#6169

# criterium1: is cartan?

allsqC1:=[];;
for d in allsq do 
	if ic(d)=0 then
	Add(allsqC1,d);
	fi;
od;
#6002

# we apply Criterium I

allsqC2:=[];;
for d in allsqC1 do 
	if cri2(d)=1 then
	Add(allsqC2,d);
	fi;
od;

Number(allsqC2);
#12

sq0:=allsqC2;;


#same, for reflections

sq1:=[];;
for d in sq0 do 
	if cri2(rho1(d))=1 then
	Add(sq1,d);
	fi;
od;
#10

sq2:=[];;
for d in sq1 do 
	if cri2(rho2(d))=1 then
	Add(sq2,d);
	fi;
od;
#8

sq3:=[];;
for d in sq2 do 
	if cri2(rho3(d))=1 then
	Add(sq3,d);
	fi;
od;
#6

sq4:=[];;
for d in sq3 do 
	if cri2(rho4(d))=1 then
	Add(sq4,d);
	fi;
od;
#4

# finally, we apply Criterium IV

sq5:=[];;
for d in sq4 do 
	if cri3(d)=1 then
	Add(sq5,d);
	fi;
od;
#0

#no squares are left.

##############################################
##############################################

#####################################
#tadpoles
#####################################

tp:=[];;
	for v in tris do
		for d in lins do
		if d[1]=v[3] and d[2]=v[4] and d[3]=v[5] and 
		Hcheckr3([v[1],v[6],v[5],d[4],d[5]])=1 
		then
		Add(tp,Concatenation(v,[d[5],d[4],F1,F1]));
		fi;
	od;
od; 
Number(tp);
#1964


#we check that all diagrams from the list are included

inc:=[];
for d in Hta4 do
if d in tp then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included


#we apply Criterium I
#We remark that we do not check for Cartan diagrams as they all contain a triangle (hence they are not of Cartan type).

tp0:=[];;
for d in tp do 
	if cri2(d)=1 then
	Add(tp0,d);
	fi;
od;
Number(tp0);
#738


tp1:=[];;
for d in tp0 do 
	if cri2(rho1(d))=1 then
	Add(tp1,d);
	fi;
od;
Number(tp1);
#598

tp2:=[];;
for d in tp1 do 
	if cri2(rho2(d))=1 then
	Add(tp2,d);
	fi;
od;
Number(tp2);
#514

tp3:=[];;
for d in tp2 do 
	if cri2(rho3(d))=1 then
	Add(tp3,d);
	fi;
od;
Number(tp3);
#344

tp4:=[];;
for d in tp3 do 
	if cri2(rho4(d))=1 then
	Add(tp4,d);
	fi;
od;
Number(tp4);
#344

#bad tadpoles:

tp4b:=[];;
for d in tp4 do
if d in Hta4 then d:=d;
else Add(tp4b,d);
fi;
od;
Number(tp4b);
#16

tacrit3:=[];
for d in tp4b do 
	if cri3(d)=1 then
	Add(tacrit3,d);
	fi;
od;
Number(tacrit3);
#0

##############################################
##############################################

#####################################
#tripods
#####################################


#build the tripods:
trips4:=[];;
	for v in lins do
		for d in lins do
		if d[1]=v[1] and d[2]=v[2] and d[3]=v[3] and
		Hcheckr3([d[5],d[4],d[3],v[4],v[5]])=1 
		then
		Add(trips4,[v[1],F1,d[5],d[4],v[3],v[2],v[5],v[4],F1,F1]);
		fi;
	od;
od; 
Number(trips4);
#32481	


#we check that all diagrams from the list are included

inc:=[];
for d in Hd4 do
if d in trips4 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

#we remove those that reflect (at vertex 3) into tadpoles/squares, already analyzed.

trtotad:=[];
for d in trips4 do 
	if checkrho3ta(d)=1 then
	Add(trtotad,d);
	fi;
od;
Number(trtotad);
#1183


#criterium one: is cartan?
tripsC1:=[];;
for d in trtotad do 
	if ic(d)=0 then
	Add(tripsC1,d);
	fi;
od;
Number(tripsC1);
#964

#we remove those, after rerflections 1, 2 or 4, reflect (at vertex 3) into tadpoles/squares, already analyzed.


tr4:=[];
for d in tripsC1 do 
	if checkrho3ta(rho1(d))*checkrho3ta(rho2(d))*checkrho3ta(rho4(d))=1 then
	Add(tr4,d);
	fi;
od;
Number(tr4);
#44

trcrit2:=[];
for d in tr4 do 
	if cri2(d)=1 then
	Add(trcrit2,d);
	fi;
od;
Number(trcrit2);
#2

 
trcrit3:=[];
for d in trcrit2 do 
	if cri3(d)=1 then
	Add(trcrit3,d);
	fi;
od;
Number(trcrit3);
#0


###################################################
###################################################

###################################################
#lines
###################################################

#build the lines:
lins4:=[];;
	for v in lins do
		for d in lins do
		if d[1]=v[3] and d[2]=v[4] and d[3]=v[5] 
		then
		Add(lins4,Concatenation(v,[F1,d[5],d[4],F1,F1]));
		fi;
	od;
od; 
Number(lins4);
#15431

#check inclusions (we remove them later)

inc:=[];
for d in Hli4 do
if d in lins4 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included


#remove inclusions from the list

li4b:=[];;
for d in lins4 do
if d in Hli4 then d:=d;
else Add(li4b,d);
fi;
od;
Number(li4b);
#13520


#criterium one: is cartan?
linsC1:=[];;
for d in li4b do 
	if ic(d)=0 then
	Add(linsC1,d);
	fi;
od;
Number(linsC1);
#13374

#we remove those that reflect into tadpoles after one reflection
litotad:=[];
for d in linsC1 do 
	if checkrhota(d)=1 then
	Add(litotad,d);
	fi;
od;
Number(litotad);
#796


#criterium 2: Criterium I
linsC2:=[];;
for d in litotad do 
	if cri2(d)=1 then
	Add(linsC2,d);
	fi;
od;
Number(linsC2);
#84

############################################


#criteria with reflections


li2:=[];;
for d in linsC2 do 
	if cri2(rho2(d))=1 then
	Add(li2,d);
	fi;
od;
Number(li2);
#80

li3:=[];;
for d in li2 do 
	if cri2(rho3(d))=1 then
	Add(li3,d);
	fi;
od;
Number(li3);
#76



#we apply Criterium IV

licrit3:=[];
for d in li3 do 
	if cri3(d)=1 then
	Add(licrit3,d);
	fi;
od;
Number(licrit3);
#56


#we apply Criterium V

licrit4:=[];
for d in licrit3 do 
	if cri4(d)=1 then
	Add(licrit4,d);
	fi;
od;
Number(licrit4);
#0






