#LogTo("criteria6.log");;


Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank5.g");
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank6.g");


######################
#creating rank 6 diagrams, by shape
######################


########################
# triangle in the middle
########################


tm6:=[];;
for d in Hli5 do
	for e in Htm5 do
		if 
		d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7]
		and [e[3],e[4],e[5],e[6],e[7],d[8],d[9],e[8],e[9],e[10]] in Hta5
		then Add(tm6,Concatenation(d,[e[8],e[9],e[10]]));
		fi;
	od;
od; 		    

tm6:=Zet(tm6);;
Number(tm6);
#42



inc:=[];;
for d in Htm6 do
if d in tm6 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0 all included

tm6bad:=[];
for d in tm6 do
if d in Hltm6 then
else
Add(tm6bad,d);
fi;
od;
Number(tm6bad);
#32


###################################
#triangle in extreme (tadpole)
###################################

ta6:=[];;
for d in Hli5 do
	for e in Hta5 do
		if 
		d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7]
		and [e[9],e[10],d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5
		then Add(ta6,Concatenation(d,[e[8],e[9],e[10]]));
		fi;
	od;
od; 	
ta6:=Zet(ta6);;   
Number(ta6);
#1048


inc:=[];
for d in Hta6 do
if d in ta6 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included


ta6bad:=[];
for d in ta6 do
if d in Hta6 then
else
Add(ta6bad,d);
fi;
od;
Number(ta6bad);
#560

###############################################
# E6
##########################################

e6:=[];;
for d in Hd5 do
	for e in Hd5 do
		if d[1]=e[5] and d[2]=e[4] and d[3]=e[3] and d[4]=e[2] and d[5]=e[1] and d[8]=e[8] and d[9]=e[9]
		and [d[7],d[6],e[1],e[2],e[3],e[4],e[5],e[6],e[7]] in Hli5
		then Add(e6,Concatenation([d[7],d[6]],e));
		fi;
	od;
od; 		    
Number(e6);
# 263

inc:=[];;
for d in He6 do
if d in e6 or Permuted(d,(1,9)(2,8)(3,7)(4,6)) in e6  then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

e6bad:=[];;
for d in e6 do
if d in He6 then
else
Add(e6bad,d);
fi;
od;

Number(e6bad);
#196


###########################
##  d6
#################################

d6:=[];;
for d in Hli5 do
	for e in Hd5 do
		if d[1]=e[1] and d[2]=e[2] and d[3]=e[3] and d[4]=e[4] and d[5]=e[5] and d[6]=e[6] and d[7]=e[7]
		and [e[9],e[8],d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5
		then Add(d6,Concatenation(d,[e[8],e[9]]));
		fi;
	od;
od; 		    
Number(d6);
#1237


inc:=[];;
for d in Hd6 do
if d in d6 or Permuted(d,(1,11)(2,10)) in d6  then
else
Add(inc,d);
fi;
od;
Number(inc);
#0, all included

d6bad:=[];;
for d in d6 do
if d in Hd6 then
else
Add(d6bad,d);
fi;
od;

Number(d6bad);
#716


###########################
##  lines....
#################################

li6:=[];;
for d in Hli5 do
	for e in Hli5 do
		if d[3]=e[1] and d[4]=e[2] and d[5]=e[3] and d[6]=e[4] and d[7]=e[5] and d[8]=e[6] and d[9]=e[7]
		then Add(li6,Concatenation(d,[e[8],e[9]]));
		fi;
	od;
od; 		    

li6:=Zet(li6);;
Number(li6);
#8577


inc:=[];;
for d in Hli6 do
if d in li6 then
else
Add(inc,d);
fi;
od;
Number(inc);
#0 all included

li6bad:=[];
for d in li6 do
if d in Hli6 then
else
Add(li6bad,d);
fi;
od;
Number(li6bad);
#2776



######################################
#criteria
######################################


########################
# triangle in the middle
########################

#Criterium I

critm1:=function(d)
local k;
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[2])] do
		if [d[3]^(n^2)*d[2]^n*d[1],d[4]^n,d[5],d[6],d[7],d[8],d[9],d[10]^n,d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[2]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10]^n*d[12],d[11]] in Hd5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[5]^(n^2)*d[4]^n*d[3],d[6]^n,d[7],d[8],d[9],d[12]^n*d[10],d[11]] in Hd5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11],d[12]^n] in Htm5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8]^n,d[9],d[10],d[11],d[12]] in Htm5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[7],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6]^n,d[7]^(n^2)*d[8]^n*d[9],d[10],d[11],d[12]] in Htm5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[9]^(n^2)*d[8]^n*d[7],d[10],d[11],d[12]] in Htm5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[8]) +1 then return 
	0; 
	else
k:=1;
		if [d[1],d[2],d[3]*d[10]*d[11],d[4]*d[12],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2],d[3],d[4]*d[10],d[5]*d[11]*d[12],d[6],d[7],d[8],d[9]] in Hli5 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

ltm6final1:=[];
for d in tm6bad do
if critm1(d)=1 then
Add(ltm6final1,d);
fi;
od;

Number(ltm6final1);
#10

#we construct reflections 1, 4 and 5 when the vertex is -1.

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

##
#crit for a1,a2+a3,a3+a4,a4+a5,a6: gives D5 since d[4]d[5]^2d[6]=1=d[6]d[7]^2d[8] for all in the remaining bad diagrams.
#and reflections
##
#This is Criterium III

critm2:=function(d)
if [d[1],d[2],d[3]*d[4]*d[5],d[10]*d[12],d[11],d[12],d[5]*d[6]*d[7],d[6],d[7]*d[8]*d[9]] in Hd5 then
return 1;
else 
return 0;
fi;
end;

critmr:=d->
critm2(d)*
critm2(rho1(d))*critm2(rho4(d))*critm2(rho5(d))*
critm2(rho1(rho4(d)))*critm2(rho5(rho4(d)))*
critm2(rho1(rho5(d)))*critm2(rho4(rho5(d)))
;

ltm6final2:=[];
for d in ltm6final1 do
if critmr(d)=1 then
Add(ltm6final2,d);
fi;
od;

Number(ltm6final2);
#0 all down.




###################################
#triangle in extreme (tadpole)
###################################

#Criterium I

crite:=function(d)
local k;
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10],d[11],d[12]^n] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[5]^(n^2)*d[4]^n*d[3],d[6]^n,d[7],d[8],d[9],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[6])] do
		if [d[1],d[2],d[3],d[4],d[7]^(n^2)*d[6]^n*d[5],d[8]^n,d[9],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[7],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6]^n,d[7]^(n^2)*d[8]^n*d[9],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[7],d[8]) +1 then return 
	0; 
	else
k:=1;
	for n in [1..mv(d[9],d[8])] do
		if [d[1],d[2],d[3],d[4],d[5],d[6],d[9]^(n^2)*d[8]^n*d[7],d[10],d[11],d[12]] in Hta5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[9],d[8]) +1 then return 
	0; 
	else
k:=1;
		if [d[11],d[10]*d[12],d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1]*d[10]*d[11],d[2]*d[12],d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
		if [d[1],d[2]*d[10],d[3]*d[12]*d[11],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
		k:=k+1;
		fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;


lte1:=[];
for d in ta6bad do
if crite(d)=1 then
Add(lte1,d);
fi;
od;
lte1:=Zet(lte1);;
Number(lte1);
#16


rho3:=function(d)
if d[5]=-F1 and d[4]*d[6]=F1 then return
[d[1],d[2],d[5]*d[4]*d[3],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10],d[11],d[12]];
else return
d;
fi;
end;

criter:=d->
crite(rho3(d))*crite(rho4(d))*crite(rho5(d))*
crite(rho3(rho4(d)))*crite(rho5(rho4(d)))*crite(rho4(rho3(d)))*
crite(rho3(rho5(d)))*crite(rho4(rho5(d)))
;

lte2:=[];
for d in lte1 do
if criter(d)=1 then
Add(lte2,d);
fi;
od;
Number(lte2);
#8


# all 8 are actually 4 with permutations, all 4 are the same with different powers of E(5).
# rho2 gives tm which is not in the list.

#rho2

ltefinal:=[];
for d in lte2 do
#if rho2(d) in Htm6 then Add(ltefinal,d);
od;
Number(ltefinal);
#0


###############################################
# E6
##########################################

#first we discard those that reflect to triangles

crie6t:=function(d)
if d[5]<>-F1 then
return 1;
elif d[5]=-F1 and d[4]*d[6]=F1 and  d[4]*d[10]=F1 and  d[10]*d[6]=F1  then
return 1;
else
return 0;
fi;
end;

#we use criteria

#Criterium I

crie6c:=function(d)
local k;
k:=1;
	if [d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[9],d[8],d[7]*d[6]*d[5],d[4],d[3],d[2],d[1],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[9]*d[8]*d[7],d[6],d[5],d[4],d[3],d[2],d[1],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5]*d[10]*d[11],d[6],d[7],d[8],d[9]] in Hli5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

crie6:=d->crie6t(d)*crie6c(d);

e6bad1:=[];;
for d in e6bad do
if crie6(d)=1 then
Add(e6bad1,d);
fi;
od;

Number(e6bad1);
#28

#we construct reflections

rho4:=function(d)
	if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10],d[11]];
else return
d;
fi;
end;

rho1:=d->Permuted(rho5(Permuted(d,(1,9)(2,8)(3,7)(4,6))),(1,9)(2,8)(3,7)(4,6));

rho2:=d->Permuted(rho4(Permuted(d,(1,9)(2,8)(3,7)(4,6))),(1,9)(2,8)(3,7)(4,6));

crie6r:=d->
crie6(rho1(d))*crie6(rho2(d))*crie6(rho4(d))*crie6(rho5(d))*
crie6(rho1(rho2(d)))*crie6(rho1(rho4(d)))*crie6(rho1(rho5(d)))*
crie6(rho2(rho1(d)))*crie6(rho2(rho4(d)))*crie6(rho2(rho5(d)))*
crie6(rho4(rho5(d)))*crie6(rho5(rho4(d)));

e6bad2:=[];
for d in e6bad1 do
if crie6r(d)=1 then
Add(e6bad2,d);
fi;
od;

Number(e6bad2);
#2

#it's the same, with powers of E(3): reflecting at 6 and then at 3 gives forbidden triangle with 3 extensions (star, forbidden).


###########################
##  d6
#################################


#first we discard those that reflect to triangles

crid6t:=function(d)
if d[3]<>-F1 then
return 1;
elif d[3]=-F1 and d[2]*d[4]=F1 and  d[4]*d[10]=F1 and  d[10]*d[2]=F1  then
return 1;
else
return 0;
fi;
end;

#we use criteria

#Criterium I

crid6c:=function(d)
local k;
k:=1;
	if [d[11],d[10],d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[8],d[9],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[10],d[11]] in Hd5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	if [d[1],d[2],d[3]*d[10]*d[11],d[4],d[5],d[6],d[7],d[8],d[9]] in Hli5 then 		
	k:=k+1;
	fi;
	if k < 2 then return
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
end;

crid6:=d->crid6t(d)*crid6c(d);

d6bad1:=[];;
for d in d6bad do
if crid6(d)=1 then
Add(d6bad1,d);
fi;
od;

Number(d6bad1);
#53

#we construct reflections

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[3]*d[2]*d[1],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]];
else return
d;
fi;
end;


rho3:=function(d)
if d[5]=-F1 and d[6]*d[4]=F1 then return
[d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10],d[11]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 and d[6]*d[8]=F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10],d[11]];
else return
d;
fi;
end;


rho6:=d->Permuted(rho1(Permuted(d,(1,11)(2,10))),(1,11)(2,10));

crid6r:=d->
crid6(rho1(d))*crid6(rho3(d))*crid6(rho4(d))*crid6(rho5(d))*crid6(rho6(d))*
crid6(rho1(rho3(d)))*crid6(rho1(rho4(d)))*crid6(rho1(rho5(d)))*crid6(rho1(rho6(d)))*
crid6(rho3(rho4(d)))*crid6(rho3(rho5(d)))*crid6(rho3(rho6(d)))*
crid6(rho4(rho3(d)))*crid6(rho4(rho5(d)))*crid6(rho4(rho6(d)))*
crid6(rho5(rho4(d)))*crid6(rho5(rho6(d)))
;

d6bad2:=[];
for d in d6bad1 do
if crid6r(d)=1 then
Add(d6bad2,d);
fi;
od;

Number(d6bad2);
#0


###########################
##  lines....
#################################



#to check if a reflection at a vertex =-1 creates a triangle
ctl6:=function(d)
if d[3]=-F1 and d[2]*d[4]<>F1 then
return 0;
elif d[5]=-F1 and d[4]*d[6]<>F1 then
return 0;
elif d[7]=-F1 and d[6]*d[8]<>F1 then
return 0;
elif d[9]=-F1 and d[8]*d[10]<>F1 then
return 0;
else
return 1;
fi;
end;

lifinal6:=[];;
for d in li6bad do
if ctl6(d)=1 then
Add(lifinal6,d);
fi;
od;
Number(lifinal6);
#1768;

li600:=lifinal6;;

#we discard lines of cartan type

crilic:=function(d)
if 
d[1]^mv(d[1],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[6])*d[6]<>F1 then return 0;
elif
d[7]^mv(d[7],d[8])*d[8]<>F1 then return 0;
elif
d[9]^mv(d[9],d[8])*d[8]<>F1 then return 0;
elif
d[9]^mv(d[9],d[10])*d[10]<>F1 then return 0;
elif
d[11]^mv(d[11],d[10])*d[10]<>F1 then return 0;
else return
1;
fi;
end;


li60:=[];
for d in li600 do
if crilic(d)=0 then
Add(li60,d);
fi;
od;
Number(li60);
#1622


#Criterium I


crilis:=function(d)
local k,t;
t:=Permuted(d,(1,11)(2,10)(3,9)(4,8)(5,7));
k:=1;
	for n in [1..mv(d[1],d[2])] do
		if [d[1]^(n^2)*d[2]^n*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[1],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[2])] do
		if [d[1]*d[2]^n*d[3]^(n^2),d[4]^n,d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[3],d[4])] do
		if [d[1],d[2]^n,d[3]^(n^2)*d[4]^n*d[5],d[6],d[7],d[8],d[9],d[10],d[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[3],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[4])] do
		if [d[1],d[2],d[3]*d[4]^n*d[5]^(n^2),d[6]^n,d[7],d[8],d[9],d[10],d[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(d[5],d[6])] do
		if [d[1],d[2],d[3],d[4]^n,d[5]^(n^2)*d[6]^n*d[7],d[8],d[9],d[10],d[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(d[5],d[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[5],t[6])] do
		if [t[1],t[2],t[3],t[4]^n,t[5]^(n^2)*t[6]^n*t[7],t[8],t[9],t[10],t[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[5],t[6])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[1],t[2])] do
		if [t[1]^(n^2)*t[2]^n*t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[1],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[2])] do
		if [t[1]*t[2]^n*t[3]^(n^2),t[4]^n,t[5],t[6],t[7],t[8],t[9],t[10],t[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[2])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[3],t[4])] do
		if [t[1],t[2]^n,t[3]^(n^2)*t[4]^n*t[5],t[6],t[7],t[8],t[9],t[10],t[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[3],t[4])+1 then return 
	0;
	else
k:=1;
	for n in [1..mv(t[5],t[4])] do
		if [t[1],t[2],t[3]*t[4]^n*t[5]^(n^2),t[6]^n,t[7],t[8],t[9],t[10],t[11]] in Hli5 then
		k:=k+1;
		fi;
	od;
	if k < mv(t[5],t[4])+1 then return 
	0;
	else
k:=1;
	return k;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
	fi;
end;


li61:=[];;
for d in li60 do
if crilis(d)=1 then
Add(li61,d);
fi;
od;

Number(li61);
#48

crili:=d->ctl6(d)*crilis(d);

#we apply the criteria to reflections at vertices=-1

rho1:=function(d)
if d[1]=-F1 then return
[d[1],d[2]^-1,d[1]*d[2]*d[3],d[4],d[5],d[6],d[7],d[8],d[9],d[10],d[11]];
else return
d;
fi;
end;

rho2:=function(d)
if d[3]=-F1 then return
[d[1]*d[2]*d[3],d[2]^-1,d[3],d[4]^-1,d[3]*d[4]*d[5],d[6],d[7],d[8],d[9],d[10],d[11]];
else return
d;
fi;
end;

rho3:=function(d)
if d[5]=-F1 then return
[d[1],d[2],d[3]*d[4]*d[5],d[4]^-1,d[5],d[6]^-1,d[5]*d[6]*d[7],d[8],d[9],d[10],d[11]];
else return
d;
fi;
end;

rho4:=function(d)
if d[7]=-F1 then return
[d[1],d[2],d[3],d[4],d[5]*d[6]*d[7],d[6]^-1,d[7],d[8]^-1,d[7]*d[8]*d[9],d[10],d[11]];
else return
d;
fi;
end;

rho5:=function(d)
if d[9]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[8]*d[9],d[8]^-1,d[9],d[10]^-1,d[9]*d[10]*d[11]];
else return
d;
fi;
end;

rho6:=function(d)
if d[11]=-F1 then return
[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],d[9]*d[10]*d[11],d[10]^-1,d[11]];
else return
d;
fi;
end;

crili6r:=d->crili(rho1(d))*crili(rho2(d))*crili(rho3(d))*crili(rho4(d))*crili(rho5(d))*crili(rho6(d));

li62:=[];
for d in li61 do
if crili6r(d)=1 then
Add(li62,d);
fi;
od;

Number(li62);
#8

li63:=[];
for d in li62 do
if crili6r(rho1(d))=1 and crili6r(rho2(d))=1 and crili6r(rho3(d))=1 and crili6r(rho4(d))=1 and crili6r(rho5(d))=1 and crili6r(rho6(d))=1 then
Add(li63,d);
fi;
od;


Number(li63);
#0
