#LogTo("valence4.log");;

Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/rank4t.g");

#there are no two consecutive triangles (necessarily joined by a vertex to avoid cycles)

#bowtie
tt:=[];
for d in Hta4 do
	for e in Hta4 do
		if d[1]=e[7] and d[6]=e[8] and d[5]=e[5] and  e[1]=d[7] and e[6]=d[8]
		and [d[1],d[2],d[3],d[4],d[5],d[6],e[3],e[4],F1,F1] in Hta4 
		and [e[1],e[2],e[3],e[4],e[5],e[6],d[3],d[4],F1,F1] in Hta4
		then Add(tt,[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],e[3],e[2],e[4]]);
		fi;
	od;
od; 		    

Number(tt);
#108

#criteria: alpha4+alpha5 and alpha1+alpha2

tt1:=[];
for d in tt do
	if [d[1],d[2],d[3],d[4],d[5],d[6],d[7]*d[10]*d[9],d[8]*d[11],F1,F1] in Hta4 and 
	[d[7],d[10],d[9],d[11],d[5],d[8],d[1]*d[2]*d[3],d[4]*d[6],F1,F1] in Hta4 then
		Add(tt1,d);
	fi;
od;

Number(tt1);
#0

#semidirect
ttr:=[];
for d in Hta4 do
	for e in Hd4 do
		if d[1]=e[7] and d[6]=e[8] and d[5]=e[5] and e[1]=d[7] and e[6]=d[8]
		and [d[1],d[2],d[3],d[4],d[5],d[6],e[3],e[4],F1,F1] in Hta4 
		and [e[1],e[2],e[3],e[4],e[5],e[6],d[3],d[4],F1,F1] in Hd4
		then Add(ttr,[d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8],e[3],e[4]]);
		fi;
	od;
od; 
Number(ttr);		    
#92


#criteria: alpha1+alpha2 (d4), alpha3+alpha4 (ta) and alpha3+alpha5 (ta)
ttr1:=[];
for d in ttr do
	if [d[7],F1,d[9],d[10],d[5],d[8],d[1]*d[2]*d[3],d[4]*d[6],F1,F1] in Hd4 
	and [d[1],d[2],d[3],d[4],d[5]*d[8]*d[7],d[6],d[9],d[10],F1,F1] in Hta4
	and [d[1],d[2],d[3],d[4],d[5]*d[9]*d[10],d[6],d[7],d[8],F1,F1] in Hta4 
	then
		Add(ttr1,d);
	fi;
od;

Number(ttr1);
#0


#we add the is cartan criterium


#is cartan:
ic:=function(d)
if 
d[1]^mv(d[1],d[2])*d[2]<>F1 then return 0;
elif
d[1]^mv(d[1],d[6])*d[6]<>F1 then return 0;
elif
d[1]^mv(d[1],d[9])*d[9]<>F1 then return 0;
#
elif
d[3]^mv(d[3],d[2])*d[2]<>F1 then return 0;
elif
d[3]^mv(d[3],d[4])*d[4]<>F1 then return 0;
elif
d[3]^mv(d[3],d[10])*d[10]<>F1 then return 0;
#
elif
d[5]^mv(d[5],d[6])*d[6]<>F1 then return 0;
elif
d[5]^mv(d[5],d[4])*d[4]<>F1 then return 0;
elif
d[5]^mv(d[5],d[8])*d[8]<>F1 then return 0;
#
elif
d[7]^mv(d[7],d[9])*d[9]<>F1 then return 0;
elif
d[7]^mv(d[7],d[10])*d[10]<>F1 then return 0;
elif
d[7]^mv(d[7],d[8])*d[8]<>F1 then return 0;
else return
1;
fi;
end;

#cross
trtr:=[];
for d in Hd4 do
	for e in Hd4 do
		if d[1]=e[7] and d[6]=e[8] and d[5]=e[5] and e[1]=d[7] and e[6]=d[8]
		and [d[1],d[2],d[3],d[4],d[5],d[6],e[3],e[4],F1,F1] in Hd4 
		and [e[1],e[2],e[3],e[4],e[5],e[6],d[3],d[4],F1,F1] in Hd4
		and ic(e)+ic(d)<2
		then Add(trtr,[d[1],d[3],d[4],d[5],d[6],d[7],d[8],e[3],e[4]]);
		fi;
	od;
od; 		    

Number(trtr);
#294


#criteria: alpha3+alpha5, alpha3+alpha4, alpha2+alpha3, alpha1+alpha3,   
trtr1:=[];
for d in trtr do
	if  [d[1],F1,d[2],d[3],d[4]*d[8]*d[9],d[5],d[6],d[7],F1,F1] in Hd4
	and [d[1],F1,d[2],d[3],d[4]*d[6]*d[7],d[5],d[8],d[9],F1,F1] in Hd4
	and [d[1],F1,d[6],d[7],d[4]*d[2]*d[3],d[5],d[8],d[9],F1,F1] in Hd4
	and [d[2],F1,d[6],d[7],d[4]*d[5]*d[1],d[3],d[8],d[9],F1,F1] in Hd4
	then Add(trtr1,d);
	fi;
od;

Number(trtr1);
#138


#we distinguish if, given vertex 3 = -F1, a reflection gives at least a triangle
f:=function(d)
local l,k,x;
k:=1;
l:=[d[3]*d[5],d[3]*d[9],d[3]*d[7],d[5]*d[9],d[5]*d[7],d[7]*d[9]];
for x in l do
	if x<>F1 then
	k:=k+1;
	fi;
od;
if k>2 then
	return 0;
else
	return 1;
fi;
end;

trtr2:=[];
for d in trtr1 do
if d[4]<>-F1 then
	Add(trtr2,d);
elif d[4]=-F1 and f(d)=1 then 
	Add(trtr2,d);
fi;
od;

Number(trtr2);
#24 (all with no -1 at vertex 3)


#we check if the reflection at outer vertices with -1 give again a diagram in the list
g:=function(d)
local k;
k:=0;
if d[1]<>-F1 or [d[1],d[2],d[3],-d[4]*d[5],d[5]^-1,d[6],d[7],d[8],d[9]] in trtr2 then
k:=k+1;
fi;
if d[2]<>-F1 or [d[1],d[2],d[3]^-1,-d[4]*d[3],d[5],d[6],d[7],d[8],d[9]] in trtr2 then
k:=k+1;
fi;
if d[6]<>-F1 or [d[1],d[2],d[3],-d[4]*d[7],d[5],d[6],d[7]^-1,d[8],d[9]] in trtr2 then
k:=k+1;
fi;
if d[8]<>-F1 or [d[1],d[2],d[3],-d[4]*d[9],d[5],d[6],d[7],d[8],d[9]^-1] in trtr2 then
k:=k+1;
fi;
return k;
end;

trtr3:=[];

for d in trtr2 do
if g(d)=4 then 
Add(trtr3,d);
fi;
od;

Number(trtr3);
#0, all down

#no vertex of valence 4 (hence or greater)





